#ifndef CORE_BOX_H
#define CORE_BOX_H

#include "core/Vector.h"

struct CoreBoxT {
    CoreVector3 min;
    CoreVector3 max;
};
typedef struct CoreBoxT CoreBox;

#define CORE_BOX ((CoreBox){0})
void coreSetBox(CoreBox* box, const CoreVector3* size);
void coreOffsetBox(CoreBox* box, const CoreVector3* offset);
bool coreCollidesWithBox(const CoreBox* box, const CoreBox* other);
void coreExpandBox(CoreBox* box, const CoreVector3* offset);
void coreGrowBox(CoreBox* box, const CoreVector3* growth);

#ifdef IMPORT_CORE
#define Box CoreBox
#define BOX CORE_BOX
#define setBox coreSetBox
#define offsetBox coreOffsetBox
#define collidesWithBox coreCollidesWithBox
#define expandBox coreExpandBox
#define growBox coreGrowBox
#endif

#endif
