#ifndef CORE_PLANE_H
#define CORE_PLANE_H

#include "core/Vector.h"

struct CorePlaneT {
    CoreVector3 abc;
    float d;
};
typedef struct CorePlaneT CorePlane;

void coreInitPlane(CorePlane* p, const CoreVector3* a, const CoreVector3* b,
                   const CoreVector3* c);
float coreSignedDistance(const CorePlane* p, const CoreVector3* v);

#ifdef IMPORT_CORE
#define Plane CorePlane
#define initPlane coreInitPlane
#define signedDistance coreSignedDistance
#endif

#endif
